%%BeginResource: procset domino
% domino procset, $Date: 1999/07/12 20:31:48 $
200 dict dup /domino.pro exch def begin

% The picture itself is stored compactly in an ASCII representation
% that is typically human-readable.  The postscript reads through this
% ASCII picture, interprets the characters appropriately, and draws
% suitable graphics.
% The user can specify one of a variety of methods for displaying
% the ASCII picture.  These methods are defined below.  The next several
% functions are for defining the postscript interpreter that reads the
% the ASCII picture.  "!" starts the interpreter.  A display method can
% define graphics for any given character, but typically "!" is defined
% to end the picture.
% Character coordinates are (i,j), where i is row, j is column.
% Any ASCII character's graphic program can access these coordinates.
/! {/i 0 def /j 0 def {cdict currentfile read pop dup /whoami exch def get exec} loop} bind def
/cdict 256 array def                  % The dictionary of character definitions
/cdef % (<chars>) {<program>}         % Define chars to do program
       {bind exch {cdict exch 2 index put} forall pop} def
/codef % (<chars>) {<program>}        % Define chars to do program at the
                                      % char's page location, increment j
       {bind
        [ {org} {} forall 2 index {} forall
          {incr grestore} {} forall ] cvx exch pop
        exch {cdict exch 2 index put} forall pop} def
/ccdef % (<chars>) {<program>} {<cond>}% Define chars to do program at the
                                      % char's page location when cond is
                                      % true, increment j
       {/cond exch cvlit def /prog exch bind cvlit def
        [ cond {} forall
          [ {org} {} forall prog {} forall
            {grestore} {} forall ] cvx
          {if incr} {} forall ] cvx bind
        exch {cdict exch 2 index put} forall pop} def
/cpdef % (<chars>) {<program>}        % Define chars to do program at the
                                      % char's page location when i and j
                                      % have the same parity, increment j
  {{i j phasor xor 1 and 0 eq} ccdef} def
/incr {/j j 1 add def} bind def

/stdchr {                             % standard character definitions
  ( ) {incr} cdef
  (!) {exit} cdef
  (\n) {/i i 1 add def /j 0 def} cdef
  (\() {{currentfile 1 string readstring pop 0 get (\)) 0 get eq {exit} if} loop} cdef
} def

% View height function as shading
/shade {
  stdchr
  1 string
  34 1 126 {
  1 index 0 3 -1 roll put dup
  {-0.5 block -0.5 block moveto 1 block 0 rlineto
    0 1 block rlineto -1 block 0 rlineto closepath
    whoami 34 sub 92 div
    0.5 sub 3 mul 0.5 add
    setgray fill} codef
  } for
  pop
} def

% View as lozenge tiling
/lozenges {
  stdchr
  /pos {hexpos} bind def
  (A) {0   rot 1 0 0 lozenge} cpdef
  (V) {0   rot cliff} cpdef
  (<) {120 rot 1 0.92 0 lozenge} cpdef
  (>) {240 rot 0 0 1 lozenge} cpdef
} def

% View as domino tiling
/dominos {
  stdchr
  (A) {270 rot 1 0 0 WT} cpdef
  (V) {90  rot 0 1 0.1 WT} cpdef
  (<) {0   rot 1 0.92 0 WT} cpdef
  (>) {180 rot 0 0 1 WT} cpdef
} def

% View as filamentous domino tiling
/filaments {
  stdchr
  (A) {270 rot 1 0 0 WT} {i 1 and 1 eq} ccdef
  (V) {90  rot 0.5 1 1 WT} {i 1 and 1 eq} ccdef
  (<) {0   rot 1 0 0 WT} {j 1 and 1 eq} ccdef
  (>) {180 rot 0.5 1 1 WT} {j 1 and 1 eq} ccdef
} def

% View as matching
/match {
  stdchr
  (A) {270 rot I} cpdef
  (V) {90  rot I} cpdef
  (<) {0   rot I} cpdef
  (>) {180 rot I} cpdef
} def

% View as domino tiling with lattice paths
/paths {
  stdchr
  (A) {270 rot T down-p} cpdef
  (V) {90  rot T up-p} cpdef
  (<) {0   rot T straight-p} cpdef
  (>) {180 rot T} cpdef
} def

% View placement-probability data as gray scale
/grays {
  stdchr
  (P) {4 {currentfile 1 string readhexstring pop 0 get 256 div dup 0 eq {pop} {prob 0 0 . 1 block 0 o} ifelse 90 rotate} repeat} cpdef
  (N) {4 {getword pop} repeat} cdef
} def

% View placement-probability data by writing numerators
/nums {
  stdchr
  /Helvetica 1 selectfont
  stringwidth pop (---) stringwidth pop add
  blocksize exch div /fsize exch def
  /Helvetica fsize selectfont
  (N) {[-90 180 -90 180] {rotate getword dup (0) eq {pop} {0.5 block -0.35 fsize mul moveto cshow 0 0 . 1 block 0 o} ifelse} forall} cpdef
  (P) {4 {currentfile 1 string readhexstring pop pop} repeat} cdef
} def

% For viewing mazes
/maze {
  stdchr
  (V) {270 rot 0 0 . I} codef
  (A) {90  rot 0 0 . I} codef
  (>) {0   rot 0 0 . I} codef
  (<) {180 rot 0 0 . I} codef
} def
/cshow {dup stringwidth pop -2 div 0 rmoveto show} def
/rshow {dup stringwidth pop neg 0 rmoveto show} def
/mazecage { % width height
  -1 block  1 block moveto
  1 index 1 add block  0 rlineto
  dup neg block 0 exch rlineto
  stroke
  1 index block 1 index neg block moveto
  1 index 1 add neg block 0 rlineto
  -1 block 0 block lineto
  stroke
  /Times-Roman findfont 0.6 block scalefont setfont
  -0.3 block 0.2 block moveto (enter MIT) rshow
  exch -0.3 add block exch neg 0.3 add block moveto (get Ph.D.) show
} def

% Character coordinates are converted to page coordinates.
% cartesian and hexagonal coordinates
/block {blocksize mul} def
/carpos {block exch block neg} bind def
/hexpos {0.5 block mul exch r32 neg} bind def
/pos {carpos} bind def
% go to the position and reset the origin
/org {gsave i j pos translate} def
/rot {rotate} bind def

/tilepath {-0.5 block -0.5 block moveto 2 block 0 rlineto 0 1 block
           rlineto -2 block 0 rlineto closepath} bind def
/itilepath {-0.45 block -0.45 block moveto 1.90 block 0 rlineto 0 0.90 block
           rlineto -1.90 block 0 rlineto closepath} bind def
/. {newpath 0.1 block 0 360 arc 0 setgray fill} def
/o {newpath 0.1 block 0 360 arc gsave 1 setgray fill grestore 0 setgray stroke} def
/. {newpath 0.1 block 0 360 arc gsave 0 setgray fill grestore 1 setgray stroke
0 setgray} def
/node {newpath 0 0 0.1 block 0 360 arc gsave 0 setgray fill grestore} def
/T {tilepath stroke} def
/ST {tilepath gsave setgray fill grestore
     stroke} def
/CT {tilepath gsave setrgbcolor fill grestore
     stroke} def
/BT {tilepath 0 0 0 setrgbcolor fill
     itilepath setrgbcolor fill} def
/WT {tilepath 1 1 1 setrgbcolor fill
     itilepath setrgbcolor fill} def
/straight-p {-0.5 block 0 moveto 2 block 0 rlineto 1 setlinewidth stroke} def
/up-p {0 0.5 block moveto 1 block -1 block rlineto 1 setlinewidth stroke} def
/down-p {0 -0.5 block moveto 1 block 1 block rlineto 1 setlinewidth stroke} def
/I {0 0 moveto 1 block 0 rlineto stroke} bind def
/J {0 0 moveto 0.5 block 0.3 block lineto 1 block 0 lineto stroke} bind def

/prob {0 0 moveto
       0.3 block 0.3 block lineto
       0.7 block 0.3 block lineto
       1 block 0 lineto
       0.7 block -0.3 block lineto
       0.3 block -0.3 block lineto
       closepath neg 1 add setgray fill
} def

/r3 {3 sqrt mul block} def
/r13 {1 3 sqrt div mul block} def
/r32 {3 sqrt 2 div mul block} def
/lozenge {0 1 r13 moveto 0.5 block -1 r32 rlineto
          -0.5 block -1 r32 rlineto -0.5 block 1 r32 rlineto
          closepath gsave setrgbcolor fill grestore} bind def
/cliff {-0.5 block -0.5 r13 moveto 1 block 0 rlineto
        -0.5 block 0.5 r3 rlineto closepath 0 0.8 0 setrgbcolor fill 0 1 r13
        moveto -0.5 block 0.5 r3 rlineto 1 block 0 rlineto closepath
        0 0.6 0.8 setrgbcolor fill} bind def
/cshow {dup stringwidth pop -2 div 0 rmoveto show} def
/in {72 mul} def
/title {
  /Times-Roman findfont 0.2 in scalefont setfont
  4.25 in exch moveto cshow
} def

/getword {[{currentfile 1 string readstring pop 0 get dup 32 eq {pop exit} if} loop]
          dup length dup string 0 1 4 -1 roll 1 sub
          {1 index exch dup 4 index exch get put} for exch pop} def

% View graphs (graph) or matchings (matching) in vax format.
% Support for various lattices
%   l4      square lattice
%   l6      hexagonal lattice
%   l8-4    square-octagonal lattice
%   l3+d    triangular lattice & dual
%   l12-6-4 dodecagon-hexagon-square lattice
% Use the phase command if the phase of the lattice in the file is different
% than that which is programmed by default.
  % the lattice position commands assume i, j (char position) are on stack,
  % convert to x, y (postscript coordinates)
  % useful constants
  /s22 2 sqrt 2 div def
  /s3 3 sqrt def
  /s32 3 sqrt 2 div def
  % two useful procedures:  x --> floor(x/{2,4})
  /fl2 {dup 0 lt {not -1 bitshift not} {-1 bitshift} ifelse} bind def
  /fl4 {dup 0 lt {not -2 bitshift not} {-2 bitshift} ifelse} bind def

  /l4      {/pos {block exch block neg} bind def} def
  /l6      {/pos {phasor 1 index 1 index xor 1 and 3 -1 roll
                  1.5 mul exch 0.5 mul sub block neg
                  exch s32 mul block exch} bind def} def
  /l3+d    {/xarr [[0 -1 0 1] [0 0 0 0] [0 1 0 -1] [0 0 0 0]] def
            /yarr [[0 0 0 0] [1 0 -1 0] [0 0 0 0] [-1 0 1 0]] def
            /pos {phasor
                  xarr 2 index 3 and get
                       1 index 3 and get
                  yarr 3 index 3 and get
                       2 index 3 and get
                  4 1 roll add
                  block 3 1 roll exch 3 div add s3 mul block neg} def} def
  /l8-4    {
            /pos {phasor
                  dup 3 and dup mul 3 mod   % (j mod 4 == 1 or 2)
                  2 index 1 and 2 mul 1 sub % (up or down)
                  mul s22 mul
                  2 index 1 and add
                  2 index fl2 2 mul  1 s22 add mul add
                  block neg 3 -1 roll pop exch
                  dup fl2  1 s22 add mul exch 1 and s22 mul add
                  block exch} bind def} def
  /l12-6-4 {/xarr [[0 1 1 1] [0 0 0 1]] def
	    /yarr [[0 2 0 2] [0 2 -1 3] [-1 3 0 2]] def
	    /ycrr [0 1 2 0 0 2 1 0] def
            /pos {phasor
                  dup dup fl4 sub s32 mul
                  1 index fl4 1.5 mul add
                  xarr 2 index fl4 4 index fl2 xor 1 and get
                       2 index 3 and get
                  2 div add block 3 1 roll
                  1 index fl2 s32 3 2 div add mul
                  3 1 roll 7 and ycrr exch get yarr exch get exch 3 and get
                  2 div add block neg} bind def} def
%  /phase {/pos [ 4 2 roll exch {4 1 roll add 3 1 roll add exch pos} bind {} forall ] cvx def} def
  /phase {/phasor [ 4 2 roll exch {4 1 roll add 3 1 roll add exch} {} forall ] cvx bind def} def
  0 0 phase
/vax {
  /matching {
  (A) {node  cut-left  cut-up bond-down  cut-right} codef
  (V) {node  cut-left bond-up  cut-down  cut-right} codef
  (<) {node  cut-left  cut-up  cut-down bond-right} codef
  (>) {node bond-left  cut-up  cut-down  cut-right} codef
  } def
  /graph {
  (X) {node bond-left bond-up bond-down bond-right} codef
  (A) {node bond-left  cut-up bond-down bond-right} codef
  (V) {node bond-left bond-up  cut-down bond-right} codef
  (<) {node  cut-left bond-up bond-down bond-right} codef
  (>) {node bond-left bond-up bond-down  cut-right} codef
  (I) {node  cut-left bond-up bond-down  cut-right} codef
  (=) {node bond-left  cut-up  cut-down bond-right} codef
  (U) {node bond-left bond-up bond-down bond-right} codef
  } def
  graph
  ( ) {      cut-left  cut-up  cut-down  cut-right incr} cdef
  (\n) {] /prev-line exch def /prev-size j def [ /i i 1 add def /j 0 def} cdef
  (\() {{currentfile 1 string readstring pop 0 get (\)) 0 get eq {exit} if} loop} cdef
  (!) {] pop exit} cdef
  /! {/i 0 def /j 0 def [ {cdict currentfile read pop get exec} loop} bind def
  /bond-left {j 0 gt {{grestore i j pos moveto i j 1 sub pos lineto stroke org} if} if} def
  /cut-left  {j 0 gt {pop} if} def
  /bond-right{true} def
  /cut-right {false} def
  /bond-down {true} def
  /cut-down  {false} def
  /cut-up    {} def
  /bond-up   {i 0 gt {j prev-size lt
                      {prev-line j get
                       {grestore i j pos moveto i 1 sub j pos lineto stroke
                        org} if} if} if} def
} def

/environ { % max-up max-down
  /max-down exch def
  /max-up exch def
  /! {
    /getline {[{currentfile read pop
                dup (\n) 0 get eq {exit} if
                dup (!) 0 get eq {/getline {false} def exit} if
               } loop ]} def
    reader} def
  /!! {
     /picturestr exch def
     /picturelen picturestr length def
     /picturepos 0 def
     /getline {[{picturepos picturelen eq {/getline {false} def exit} if
                 picturestr picturepos get /picturepos picturepos 1 add def
                 dup (\n) 0 get eq {exit} if} loop ]} def
     getline pop % first line is assumed to be blank and to be ignored
     reader} def
  /neighbor {{ % deltx delty
              band exch neg max-up add get
              dup false eq {pop pop ( ) 0 get exit} if
              exch j add
              dup 0 lt {pop pop ( ) 0 get exit} if
              dup 2 index length ge {pop pop ( ) 0 get exit} if
              get exit} loop} def
  /reader {
      /i 0 def /j 0 def
      /band [ max-up 1 add {[]} repeat
              max-down {getline} repeat] def
      {/band [band {} forall getline max-up max-down 2 add add -1 roll pop] def
       band max-up get dup false eq {pop exit} if
                       {dup /whoami exch def cdict exch get exec} forall
       /i i 1 add def /j 0 def
      } loop
     } def
} def
% make enveloping bubble around points
% support for KPW pictures
/bubrad {0.25 block} def
/in0-360 { % angle
   {dup   0 lt {360 add} {exit} ifelse} loop
   {dup 360 ge {360 sub} {exit} ifelse} loop
} def


% \__     x1,y1
%    \__     \         _____x3,y3
%       \__   \/------/
%          \_x2,y2
%             \__     bend
%    slope       \__
%                   \__
% 		       \_
/bubbarc { % x1 y1 x2 y2 x3 y3
  /y3 exch def /x3 exch def
  /y2 exch def /x2 exch def
  /y1 exch def /x1 exch def
  /deg1 x1 x3 eq y1 y3 eq and def
  x2 y2 translate
  /x1 x1 x2 sub def
  /x3 x3 x2 sub def
  /y1 y1 y2 sub def
  /y3 y3 y2 sub def
  /slope y3 x3 atan dup y1 x1 atan add 2 div 90 add in0-360
    dup 3 1 roll sub 90 add in0-360 180 gt {180 add in0-360} if def
  /bend y3 x3 atan slope sub 90 add in0-360 90 sub def

  /offang slope bend sub 90 sub def
  /x1 x1 2 div offang cos bubrad mul add def
  /y1 y1 2 div offang sin bubrad mul add def
  /offang slope bend add 90 sub def
  /x3 x3 2 div offang cos bubrad mul add def
  /y3 y3 2 div offang sin bubrad mul add def

  errordict /nocurrentpoint
  errordict /nocurrentpoint get
  errordict /nocurrentpoint {pop moveto} put
  x1 y1 lineto
  put
  deg1 {
    0 0 bubrad slope slope 180 add arc
  } {
  bubrad bend cos div dup
  slope 90 sub cos mul exch
  slope 90 sub sin mul
    x3 y3 bubrad arct
  } pop {
    bend 0 gt
    {0 0 bubrad slope 90 sub bend sub slope 90 sub bend add arc}
    {bubrad 2 mul bend cos div dup
       slope 90 sub cos mul exch
       slope 90 sub sin mul
     bubrad slope 90 add bend sub slope 90 add bend add arcn}
    ifelse
  } ifelse
  x3 y3 lineto
  x2 neg y2 neg translate
} def
/dirs4 [[-1 0] [0 -1] [1 0] [0 1]] def
/dirs6 [[-1 0] [-2 -1] [0 -1] [2 -1] [1 0] [2 1] [0 1] [-2 1]] def
/dirs6 {
  i j xor 1 and 0 eq
  {[[-1 0] [-2 -1] [0 -1] [2 -1] [1 0]       [0 1]       ]}
  {[[-1 0]         [0 -1]        [1 0] [2 1] [0 1] [-2 1]]}
  ifelse
} def
/charinstr {% c str
  false
  0 1 3 index length 1 sub
      {2 index exch get 3 index eq {pop true exit} if} for
  3 1 roll pop pop
} def
/typedirs {% [[deltx delty] ...] (chars)
           % OR ELSE
           % [[deltx delty (chars)] ...]
  dup type /stringtype eq {
  [ 3 1 roll exch {dup {} forall neighbor 2 index charinstr not
                         {pop} {exch} ifelse} forall pop ]} {
  [ exch {dup {} forall 3 1 roll neighbor exch charinstr not
                         {pop} {[ exch {} forall pop ]} ifelse} forall]
  } ifelse
} def
/ondirs { % {op for each arc}
  /ateach exch def
  dup length dup 0 eq
   {i j pos bubrad 0 360 arc ateach}
   {0 1 2 index 1 sub
     {2 index 1 index get
       {} forall neg i add exch j add pos
      i j pos
      6 index 5 index 1 add 7 index mod get
       {} forall neg i add exch j add pos
      bubbarc ateach
      pop
     } for}
  ifelse pop
} def
/vfdraw { % [dirs] <shade> [<rad>]
  newpath
  1 index type /arraytype eq {0.25} if
  block /bubrad exch def
  exch 1 string dup 0 whoami put typedirs
  {} ondirs
  closepath exch setgray fill
  0 setgray
  {stroke} ondirs pop
} def
/edgeconnect {
  dirs4 (e.) typedirs
  {{} forall neg i add exch j add pos moveto i j pos lineto stroke} forall
} def
/arrow {                                         % x1 y1 x2 y2 scale rad
        6 2 roll
        gsave 1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate                % radius
        1 index sub
        3 1 roll 0 translate gsave 0 setlinewidth dup dup scale
        0 0 moveto 1 -0.5 lineto 0.75 0 lineto 1 0.5 lineto closepath fill grestore
        0.5 mul 0 moveto 0 lineto stroke
        grestore} def
/edgeconnect6 {
  [[-1 0 (e<)] [1 0 (e>)] [0 1 (eA)]] typedirs
  {{} forall neg i add exch j add pos moveto i j pos lineto stroke} forall
} def
/edgeconnect6a {
  [[-1 0 (e<)] [1 0 (e>)] [0 1 (eA)]] typedirs
  {{} forall neg i add exch j add pos moveto i j pos lineto stroke} forall
  [[-2 1 (>)] [2 1 (<)] [0 -1 (A)]] typedirs
  {{} forall neg i add exch j add pos i j pos 0.5 block 0.25 block arrow} forall
} def
/edgeconnect6p {
  [[-1 0 (<)] [1 0 (>)] [0 1 (A)]] typedirs
  {{} forall neg i add exch j add pos i j pos
   4 2 roll 0.2 block 0.1 block arrow} forall
  [[-2 1 (>)] [2 1 (<)] [0 -1 (A)]] typedirs
  {{} forall neg i add exch j add pos i j pos
   gsave [1 3] 0 setdash moveto lineto stroke grestore} forall
} def
/edgeconnect6f {
  [[-1 0 (eA>)] [1 0 (e<A)] [0 1 (e<>)]] typedirs
  {{} forall neg i add exch j add pos moveto i j pos lineto stroke} forall
} def
/bubble {
  1 1 environ
  ( \n) {} codef
  (o) {dirs4 (o) typedirs
       {} ondirs
       closepath 1 0 0 setrgbcolor fill
       {0 1 0 setrgbcolor stroke} ondirs pop
       incr} cdef
} def
/kpw-g {
  1 1 environ l4
  ( \n) {} codef
  (vV){edgeconnect dirs4 0   vfdraw incr} cdef
  (fF){incr} cdef
  (e) {} codef
} def
/kpw6-g {
  1 1 environ l6
  ( \n) {} codef
  (vV){edgeconnect6a dirs6 0   vfdraw incr} cdef
  (fF){incr} cdef
  (e<>A) {} codef
} def
/kpw-g+d {
  1 1 environ l4
  ( \n) {} codef
  (vV){edgeconnect dirs4 0   vfdraw incr} cdef
  (fF){edgeconnect dirs4 0.6 vfdraw incr} cdef
  (e) {node} codef
} def
/kpw6-g+d {
  1 1 environ l6
  ( \n) {} codef
  (vV){edgeconnect6p dirs6 0   vfdraw incr} cdef
  (fF){edgeconnect6f dirs6 0.6 vfdraw incr} cdef
  (e<>A) {node} codef
} def
/kpw-d {
  1 1 environ l4
  ( \n) {} codef
  (vV){incr} cdef
  (fF){edgeconnect dirs4 0.6   vfdraw incr} cdef
  (e) {} codef
} def
/kpw6-d {
  1 1 environ l6
  ( \n) {} codef
  (vV){incr} cdef
  (fF){edgeconnect6f dirs6 0.6   vfdraw incr} cdef
  (e<>A) {} codef
} def
/kpw-hg {
  1 1 environ l4
  ( VF\n) {} codef
  (v) {edgeconnect dirs4 0 0.1 vfdraw incr} cdef
  (f) {edgeconnect dirs4 0 0.1 vfdraw incr} cdef
  (e) {            dirs4 1 0.1 vfdraw incr} cdef
} def
/kpw6-hg {
  1 1 environ l6
  ( VF\n) {} codef
  (v) {edgeconnect6  dirs6 0 0.1 vfdraw incr} cdef
  (f) {edgeconnect6f dirs6 0 0.1 vfdraw incr} cdef
  (e<>A) {           dirs6 1 0.1 vfdraw incr} cdef
} def
/whiteedge {
  1 1 environ
  ( VF\n) {} codef
  (v) {} codef
  (f) {} codef
  (e<>A) {           dirs6 1 0.1 vfdraw incr} cdef
} def
/cvas {dup length string dup 0 1 2 index length 1 sub {dup 4 index exch get put dup} for pop exch pop} def
/dual { % given picture of planar graph, make dual
  [ exch {{
   dup ( \n\t\f\r) charinstr {exit} if
   dup (v) charinstr { pop (f) 0 get exit} if
   dup (V) charinstr { pop (F) 0 get exit} if
   dup (f) charinstr { pop (v) 0 get exit} if
   dup (F) charinstr { pop (V) 0 get exit} if
   dup (e<>A) charinstr { pop (e) 0 get exit} if
   pop (?) 0 get exit
   } loop} forall ] cvas
} def
% illustrations of the generalized Temperley bijection
/panelxgap 5 def
/panelygap 2 def
/kpw4 { % pic width height
  gsave
  0 0 2 index 2 mul panelygap add 4 index 2 mul panelxgap add
  l4 domcenter
  panelygap add exch panelxgap add exch
  2 index kpw-g !!
  1 index 0 exch pos translate
  2 index kpw-d !!
  1 index neg 1 index exch pos translate
  2 index kpw-g+d !!
  2 index whiteedge !!
  pop 0 exch pos translate
  dup kpw-hg !!
  whiteedge !!
  grestore
  showpage
} def
/kpw84 { % pic width height
  gsave
  0 0 2 index 3 mul panelygap 2 mul add 4 index 2 mul panelxgap add
  l4 domcenter
  panelygap add exch panelxgap add exch
  2 index kpw-g !!
  1 index 0 exch pos translate
  2 index kpw-d !!
  1 index neg 1 index exch pos translate
  2 index kpw-g+d !!
  2 index whiteedge !!
  1 index 0 exch pos translate l8-4
  2 index kpw-d !!
  1 index neg 1 index exch l4 pos translate
  2 index kpw-g+d !!
  2 index whiteedge !!
  pop 0 exch pos translate
  dup kpw-hg !!
  whiteedge !!
  grestore
  showpage
} def
/kpw6 { % pic width height
  gsave
  0 0 2 index 2 mul panelygap add 4 index 2 mul panelxgap add
  l6 domcenter
  panelygap add exch panelxgap add exch
  2 index kpw6-g !!
  1 index 0 exch pos pop 0 translate
  2 index kpw6-d !!
  1 index neg 1 index exch pos translate
  2 index kpw6-g+d !!
  2 index whiteedge !!
  pop 0 exch pos pop 0 translate
  dup kpw6-hg !!
  whiteedge !!
  grestore
  showpage
} def
% Same idea, but rotate 30 degrees
/kpw6-30 { % pic width height
  /xcent 2 index 2 idiv def
  /ycent 1 index 2 idiv def
  /spin {gsave xcent ycent pos 1 index 1 index translate
         30 rotate neg exch neg exch translate} def
  /unspin {grestore} def
  gsave
  0 0 2 index 2 mul panelygap add 4 index 2 mul panelxgap add
  l6 domcenter
  panelygap add exch panelxgap add exch
  spin
  2 index kpw6-g !!
  unspin
  1 index 0 exch pos pop 0 translate
  spin
  2 index kpw6-d !!
  unspin
  1 index neg 1 index exch pos translate
  spin
  2 index kpw6-g+d !!
  2 index whiteedge !!
  unspin
  pop 0 exch pos pop 0 translate
  spin
  dup kpw6-hg !!
  whiteedge !!
  unspin
  grestore
  showpage
} def
% number of neighbors [test of environ]
/nn {
  1 1 environ
  /Times-Roman 12 selectfont
  (*) {0 [[-1 0] [-1 1] [0 1] [1 1] [1 0] [1 -1] [0 -1] [-1 -1]]
       {{} forall neighbor (*) 0 get eq {1 add} if} forall
       1 string cvs 0 -6 moveto cshow} codef
  ( ) {} codef
} def
/backbone {
/bb { % depth dir i j
  gsave pos translate rotate
  %log 2 mul setlinewidth
  0 0 moveto 2 block 0 lineto stroke
  grestore
} bind def
/gray {3 -1 roll 3234 div sqrt neg 1 add setgray} def
/pink {3 -1 roll 3234 div sqrt neg 1 add dup 1 3 1 roll setrgbcolor} def
/gray {3 -1 roll pop 0 setgray} def
/pink {3 -1 roll pop 1 0 0 setrgbcolor} def
/A {gray 270 3 1 roll bb } def
/V {gray  90 3 1 roll bb } def
/C {gray   0 3 1 roll bb } def
/D {gray 180 3 1 roll bb } def
/a {pink 270 3 1 roll bb } def
/v {pink  90 3 1 roll bb } def
/c {pink   0 3 1 roll bb } def
/d {pink 180 3 1 roll bb } def
} def
% move the origin and set the blocksize so that
% the picture is centered on the page
/domcenter { % top left bottom right
  0.3 setlinewidth
  /blocksize 1 def
  3 index 1 sub 3 index 1 sub pos
  3 index 1 add 3 index 1 add pos
  3 index 2 index sub neg 6.5 in exch div
  3 index 2 index sub       9 in exch div
  1 index 1 index gt {exch} if pop /blocksize exch def
  4 {pop} repeat
  3 index 1 sub 3 index 1 sub pos
  3 index 1 add 3 index 1 add pos
  3 index 2 index add 2 div neg 4.25 in add
  3 index 2 index add 2 div neg 5.5 in add
  translate
  8 {pop} repeat
} def
end
%%EndResource
