%%BeginResource: procset graph
% graph procset, $Date: 1998/03/25 05:17:49 $
200 dict dup /graph.pro exch def begin

% Procset for illustrating concepts using a certain particular
% planar graph.  Examples of such illustrations include Kasteleyn
% matrices, matrix-tree theorem, cycle-popping, and soon the generalized
% Temperley bijection.

/rad 3 def
/arrow {gsave 0 setlinewidth
        1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate                % radius
        rad 0 translate rad sub rad sub
        0 0 moveto 12 -6 lineto 9 0 lineto 12 6 lineto closepath fill
        2 setlinewidth
        4 0 moveto 0 lineto stroke
        grestore} def
/barrow {gsave 0 setlinewidth 0.9 setgray
        1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate                % radius
        rad 0 translate rad sub rad sub
        0 0 moveto 12 -6 lineto 9 0 lineto 12 6 lineto closepath fill
        5 setlinewidth
        4 0 moveto 0 lineto stroke
        grestore} def
/sarrow {gsave 0 setlinewidth
        1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate 3 -6 translate 6 sub       % radius
        rad 0 translate rad sub rad sub
        0 0 moveto 12 -6 lineto 9 0 lineto 12 6 lineto closepath fill
        2 setlinewidth
        4 0 moveto 0 lineto stroke
        grestore} def
/sidestep {18 cos 10 mul 18 sin -10 mul translate 18 cos 20 mul sub} def
/larrow {3 1 roll exch {} forall 3 -1 roll {} forall
        gsave 0 setlinewidth
        1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate sidestep       % radius
        0 0 moveto 9 -4.5 lineto 6.75 0 lineto 9 4.5 lineto closepath fill
        1 setlinewidth
        dup
        4 0 moveto 0 lineto stroke
        180 rotate -2 div 3 moveto 3 string cvs cshow
        grestore} def
/farrow {3 1 roll exch {} forall 3 -1 roll {} forall
        gsave 0 setlinewidth
        1 index 1 index translate
        neg 3 -1 roll add 3 1 roll sub exch      % delt-x delt-y
        1 index dup mul 1 index dup mul add sqrt % delt-x delt-y radius
        3 1 roll exch atan rotate sidestep       % radius
        0 0 moveto 9 -4.5 lineto 6.75 0 lineto 9 4.5 lineto closepath fill
        3 setlinewidth
        dup
        4 0 moveto 0 lineto stroke
        180 rotate -2 div 3 moveto 3 string cvs cshow
        grestore} def

/m {{} forall moveto} def
/l {{} forall lineto} def
/. {{} forall newpath 3 0 360 arc fill} def
/e {{} forall m l stroke} def
/be {gsave 5 setlinewidth 0.4 setgray {} forall m l stroke grestore} def
/vbe {gsave 8 setlinewidth 0.7 setgray {} forall m l stroke grestore} def
/de {{} forall exch {} forall 2 index {} forall arrow pop} def
/bde {{} forall exch {} forall 2 index {} forall barrow pop} def
/se {{} forall exch {} forall 2 index {} forall sarrow pop} def
/rshow {dup stringwidth pop neg 0 rmoveto show} def
/cshow {dup stringwidth pop -2 div 0 rmoveto show} def
/sep {gsave {} forall translate newpath
      0.8 setgray 0 0 7 0 360 arc fill
      0 setgray 0 0 7 0 360 arc stroke
      grestore} def
/lab {gsave exch {} forall translate newpath
      1 setgray 0 0 10 0 360 arc fill
      0 setgray 0 0 10 0 360 arc stroke
      0 -5 moveto cshow grestore} def
/wlab {gsave exch {} forall translate newpath
      gsave 2 1 scale
      1 setgray 0 0 10 0 360 arc fill
      0 setgray 0 0 10 0 360 arc stroke
      grestore
      0 -5 moveto cshow grestore} def
/labs {
 /Helvetica 14 selectfont
 p1 (1) lab
 p2 (2) lab
 p3 (3) lab
 p4 (4) lab
 p5 (5) lab
 p6 (6) lab
 p7 (7) lab
 p8 (8) lab
 p10 (10) lab
 p11 (11) lab
 p12 (12) lab
 p13 (13) lab
 p14 (14) lab
 p9 (9) lab
} def

/contract {% two point labels
  currentdict 2 index get {} forall
  currentdict 3 index get {} forall
  exch 4 -1 roll add 2 div [ exch
  4 2 roll add 2 div ]
  dup 4 1 roll def
  exch def} def

/p1  [0 210] def
/p2  [20 160] def
/p3  [50 110] def
/p4  [110 60] def
/p5  [170 30] def
/p6  [220 80] def
/p7  [210 150] def
/p8  [180 215] def
/p10 [90 240] def
/p11 [40 225] def
/p12 [55 180] def
/p12a [46 186] def
/p12b [55 180] def
/p12c [64 174] def
/p13 [100 125] def
/p13a [90 123] def
/p13b [100 125] def
/p13c [110 127] def
/p14 [150 110] def
/p14a [140 90] def
/p14b [145 98] def
/p14c [150 106] def
/p14d [155 114] def
/p14e [160 122] def
/p9 [115 190] def
/p9a [120 198] def
/p9b [115 190] def
/p9c [110 182] def
/f1 [p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11] def
/f2 [p12 p13 p9] def
/av {[p1 p2 p3 p4 p5 p6 p7 p8 p10 p11 p12 p13 p14 p9] {.} forall} def
/vsp {[p1 p2 p3 p4 p5 p6 p7 p8 p10 p11 p12a p12b p12c p13a p13b p13c p14a p14b p14c p14d p14e p9a p9b p9c] {.} forall} def
/ledge {% edge label
  exch gsave
  {} forall exch dup {} forall translate
} def
/ntes [[p1 p2] [p2 p3] [p3 p4] [p4 p5] [p5 p6] [p6 p7] [p7 p8]
       [p10 p11] [p11 p1] [p12 p9] [p12 p13] [p3 p13] [p6 p14]] def
/tes  [[p12 p2] [p12 p11] [p9 p10] [p10 p8] [p9 p8]
       [p9 p13] [p14 p13] [p4 p14] [p14 p5] [p14 p7]] def

/weights [
 [p1 p2 2] [p1 p11 1]
 [p2 p1 1] [p2 p3 2] [p2 p12 2]
 [p3 p2 3] [p3 p4 1] [p3 p13 1]
 [p4 p3 1] [p4 p5 3] [p4 p14 2]
 [p5 p4 1] [p5 p6 2] [p5 p14 3]
 [p6 p5 1] [p6 p7 1] [p6 p14 4]
 [p7 p6 3] [p7 p8 2] [p7 p14 1]
 [p8 p7 2] [p8 p9 1] [p8 p10 1]
 [p9 p8 1] [p9 p10 0] [p9 p12 4] [p9 p13 2]
 [p10 p8 2] [p10 p9 1] [p10 p11 2]
 [p11 p10 3] [p11 p12 1] [p11 p1 1]
 [p12 p2 1] [p12 p11 0] [p12 p9 2] [p12 p13 3]
 [p13 p3 1] [p13 p9 2] [p13 p12 1] [p13 p14 1]
 [p14 p4 1] [p14 p5 1] [p14 p6 1] [p14 p7 1] [p14 p13 1]] def
/tree [
 [p1 p11 1]
 [p2 p12 2]
 [p3 p2 3]

 [p5 p14 3]
 [p6 p14 4]
 [p7 p6 3]
 [p8 p7 2]
 [p9 p12 4]
 [p10 p11 2]
 [p11 p12 1]
 [p12 p13 3]
 [p13 p14 1]
 [p14 p4 1]] def

/es {[[p1 p2] [p2 p3] [p3 p4] [p4 p5] [p5 p6] [p6 p7] [p7 p8]
     [p10 p11] [p11 p1] [p12 p9] [p12 p13] [p3 p13] [p6 p14]
     [p12 p2] [p12 p11] [p9 p10] [p10 p8] [p9 p8]
     [p9 p13] [p14 p13] [p4 p14] [p14 p5] [p14 p7]]} def
/esp [[p1 p2] [p2 p3] [p3 p4] [p4 p5] [p5 p6] [p6 p7] [p7 p8]
     [p10 p11] [p11 p1] [p12c p9c] [p12c p13a] [p3 p13a] [p6 p14e]
     [p12a p2] [p12a p11] [p9a p10] [p10 p8] [p9a p8]
     [p9c p13c] [p14c p13c] [p4 p14a] [p14a p5] [p14e p7]
     [p12a p12b] [p12b p12c]
     [p13a p13b] [p13b p13c]
     [p14a p14b] [p14b p14c] [p14c p14d] [p14d p14e]
     [p9a p9b] [p9b p9c]] def
/match2  [[p3 p4] [p5 p6] [p7 p8] [p11 p1]
         [p12 p2] [p9 p10] [p14 p13]] def
/match2sp  [[p3 p4] [p5 p6] [p7 p8] [p11 p1]
         [p12a p2] [p9a p10] [p14c p13c]
         [p12b p12c] [p13a p13b] [p14a p14b] [p14d p14e] [p9b p9c]
] def
/match1 [[p1 p2] [p3 p4] [p5 p6]
         [p12 p11] [p10 p8]
         [p9 p13] [p14 p7]] def
/match1sp [[p1 p2] [p3 p4] [p5 p6]
         [p12a p11] [p10 p8]
         [p9c p13c] [p14e p7]
         [p12b p12c] [p13a p13b] [p14a p14b] [p14d p14c] [p9b p9a]
] def


/kast [
(0 + 0 0 0 0 0 0 0 0 - 0 0 0)
(- 0 + 0 0 0 0 0 0 0 0 - 0 0)
(0 - 0 + 0 0 0 0 0 0 0 0 + 0)
(0 0 - 0 + 0 0 0 0 0 0 0 0 +)
(0 0 0 - 0 + 0 0 0 0 0 0 0 -)
(0 0 0 0 - 0 + 0 0 0 0 0 0 +)
(0 0 0 0 0 - 0 + 0 0 0 0 0 -)
(0 0 0 0 0 0 - 0 - - 0 0 0 0)
(0 0 0 0 0 0 0 + 0 + 0 - + 0)
(0 0 0 0 0 0 0 + - 0 + 0 0 0)
(+ 0 0 0 0 0 0 0 0 - 0 - 0 0)
(0 + 0 0 0 0 0 0 + 0 + 0 + 0)
(0 0 - 0 0 0 0 0 - 0 0 - 0 -)
(0 0 0 - + - + 0 0 0 0 0 + 0)
] def
/laplacian [
[-3 2 0 0 0 0 0 0 0 0 1 0 0 0]
[1 -5 2 0 0 0 0 0 0 0 0 2 0 0]
[0 3 -5 1 0 0 0 0 0 0 0 0 1 0]
[0 0 1 -6 3 0 0 0 0 0 0 0 0 2]
[0 0 0 1 -6 2 0 0 0 0 0 0 0 3]
[0 0 0 0 1 -6 1 0 0 0 0 0 0 4]
[0 0 0 0 0 3 -6 2 0 0 0 0 0 1]
[0 0 0 0 0 0 2 -4 1 1 0 0 0 0]
[0 0 0 0 0 0 0 1 -5 0 0 4 0 0]
[0 0 0 0 0 0 0 2 1 -5 2 0 0 0]
[1 0 0 0 0 0 0 0 0 3 -5 1 0 0]
[0 1 0 0 0 0 0 0 2 0 0 -6 3 0]
[0 0 1 0 0 0 0 0 2 0 0 1 -5 1]
[0 0 0 1 1 1 1 0 0 0 0 0 1 -5]
] def

/ikast [
[[0 1] [-5 9] [-1 6] [-4 9] [-5 18] [-1 3] [-7 18] [-2 9] [2 9] [1 6] [4 9] [-1 6] [-1 9] [1 9]]
[[5 9] [0 1] [-1 6] [-1 9] [-1 6] [-1 9] [-1 6] [-1 9] [-1 9] [5 18] [0 1] [5 18] [1 9] [0 1]]
[[1 6] [1 6] [0 1] [-1 2] [-1 6] [-1 3] [-1 3] [-1 6] [0 1] [1 3] [1 6] [-1 6] [-1 3] [1 6]]
[[4 9] [1 9] [1 2] [0 1] [-5 18] [-2 9] [-1 18] [-4 9] [-1 3] [7 18] [1 9] [1 18] [1 9] [-2 9]]
[[5 18] [1 6] [1 6] [5 18] [0 1] [-5 9] [-1 6] [-7 18] [-2 9] [7 18] [1 6] [-1 9] [-1 9] [1 6]]
 [[1 3] [1 9] [1 3] [2 9] [5 9] [0 1] [-2 9] [-2 9] [-1 9] [1 3] [1 9] [0 1] [-1 9] [-2 9]]
[[7 18] [1 6] [1 3] [1 18] [1 6] [2 9] [0 1] [-11 18] [-4 9] [4 9] [1 6] [-1 18] [1 9] [1 6]]
 [[2 9] [1 9] [1 6] [4 9] [7 18] [2 9] [11 18] [0 1] [1 9] [5 18] [1 9] [-1 18] [-1 3] [-2 9]]
  [[-2 9] [1 9] [0 1] [1 3] [2 9] [1 9] [4 9] [-1 9] [0 1] [-4 9] [1 9] [2 9] [-2 9] [-2 9]]
 [[-1 6] [-5 18] [-1 3] [-7 18] [-7 18] [-1 3] [-4 9] [-5 18] [4 9] [0 1] [-5 18] [-1 6] [1 9] [1 18]]
[[-4 9] [0 1] [-1 6] [-1 9] [-1 6] [-1 9] [-1 6] [-1 9] [-1 9] [5 18] [0 1] [5 18] [1 9] [0 1]]
[[1 6] [-5 18] [1 6] [-1 18] [1 9] [0 1] [1 18] [1 18] [-2 9] [1 6] [-5 18] [0 1] [-2 9] [1 18]]
 [[1 9] [-1 9] [1 3] [-1 9] [1 9] [1 9] [-1 9] [1 3] [2 9] [-1 9] [-1 9] [2 9] [0 1] [2 9]]
 [[-1 9] [0 1] [-1 6] [2 9] [-1 6] [2 9] [-1 6] [2 9] [2 9] [-1 18] [0 1] [-1 18] [-2 9] [0 1]]
] def

/fracshow {{} forall exch dup 0 eq {(0) cshow}
   {gsave 4 string cvs 0 4 rmoveto rshow grestore
    gsave (/) cshow grestore
    4 string cvs 0 -4 rmoveto show} ifelse} def

/fmatshow {/tr exch def gsave
           {gsave {tr 0 translate 0 0 moveto fracshow} forall grestore 0 tr neg translate} forall grestore} def

/kshow {/tr exch def gsave
        {gsave 0 2 2 index length 1 sub {1 index exch get tr 0 translate 0 0 moveto
         dup 48 eq {(0) cshow} if
         dup 49 eq {(1) cshow} if
         dup 42 eq {(*) cshow} if
         dup 43 eq {(+1) cshow} if
             45 eq {(-1) cshow} if
        } for pop grestore 0 tr neg translate} forall grestore} def

/lashow {/tr exch def gsave
        {gsave 0 1 2 index length 1 sub {1 index exch get tr 0 translate 0 0 moveto
         neg 3 string cvs cshow
        } for pop grestore 0 tr neg translate} forall grestore} def

/grayout {/tr exch def
          0.7 setgray { dup
          1 sub tr mul neg tr 2 div exch 4 sub moveto
          0 tr 2 sub rlineto
          14 tr mul 0 rlineto
          0 2 tr sub rlineto
          closepath fill
          0.5 sub tr mul tr 5 sub moveto
          tr 2 sub 0 rlineto
          0 -14 tr mul rlineto
          2 tr sub 0 rlineto
          closepath fill} forall
          0 setgray} def
/e29s {
/Helvetica 18 selectfont
0 -4 moveto (=) show

30 0 translate
7.5 4 moveto (2) cshow
0 0 moveto 15 0 lineto stroke
7.5 -14 moveto (9) cshow

/Helvetica 41 selectfont
-12 -9 moveto (\( \)) show

/Helvetica 14 selectfont
20 17 moveto (2) show
} def

/down {y add /y exch def} def
/mid  {11 72 mul 2 div y neg moveto} def
/pmid {8.5 72 mul 2 div y neg moveto} def
/mar  {50 y neg moveto} def

/Helvetica findfont
dup length dict begin
 {1 index /FID ne {def} {pop pop} ifelse} forall
 /Encoding ISOLatin1Encoding def
 currentdict
end
/Helvetica-ISO exch definefont pop
/pow {0 15 rmoveto 0.75 0.75 scale show 4 3 div dup scale 0 -15 rmoveto} def
/wop {0 -7 rmoveto 0.75 0.75 scale show 4 3 div dup scale 0 7 rmoveto} def
/sqrtn {
   0 -5 rmoveto /Symbol 30 selectfont gsave (\326) show grestore
   (\140) show gsave -7 0 rmoveto (\140) show grestore
   0 5 rmoveto /Helvetica-Oblique 30 selectfont (n) show} def

/mat20 {
 15 18 moveto  10 18 lineto  10 -267 lineto  15 -267 lineto stroke
285 18 moveto 290 18 lineto 290 -267 lineto 285 -267 lineto stroke
} def
/mat20l {
 15 18 moveto  10 18 lineto  10 -267 lineto  15 -267 lineto stroke
 25 18 moveto  30 18 lineto  30 -267 lineto  25 -267 lineto stroke
} def
end
%%EndResource
